    include     \masm32\include\masm32rt.inc    ; defaults to .386

    .586

    include     timers.asm      ; requires a pentium

    LOOPCOUNT equ 1000000

    PROCS TEXTEQU <lszLenSSE,FStrLen,Ratch,szLength,szLen>

    SIZES TEXTEQU <0,1,2,3,5,8,13,21,34,55,89,144,233>

    HPROC TEXTEQU <szLength>        ; Function to calculate length for header

    %FOR proc,<PROCS>
         proc proto :DWORD
    ENDM

    MAXWIDTH  equ 20
    HDRWIDTH  equ 10
    COLWIDTH  equ 5

.data

    %FOR len,<SIZES>
         align 16
         str&len& db len dup ('X'),0
    ENDM

.code

align 16

sxFld proc DDpointer:DWORD, rvstring:DWORD, DDwidth:DWORD, DDalign:DWORD
    .if DDalign == 0                    ; align left?
        invoke szLeft,DDpointer,rvstring,DDwidth
        invoke szLen,rvstring
        mov edx,rvstring
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+eax],32
        inc eax
        jmp @B
    @@: mov byte ptr [edx+eax],0
    .elseif DDalign == 1                ; align right?
        invoke szLen,DDpointer
        mov edx,rvstring
        xor ecx,ecx
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+ecx],32
        inc eax
        inc ecx
        jmp @B
    @@: add edx,ecx
        invoke szLeft,DDpointer,edx,DDwidth
    .endif
    ret 4*4

sxFld endp

fld$ MACRO DDpointer,DDwidth,DDalign:=<0>       ; Default is align left
    LOCAL rvstring
    .data
        rvstring db MAXWIDTH+4 dup (0)
        align 16
    .code
    invoke sxFld,reparg(DDpointer),ADDR rvstring,DDwidth,DDalign
    EXITM <ADDR rvstring>
ENDM

.code

align 16

start:

    print fld$(chr$("Proc/Bytes"),HDRWIDTH)
    %FOR len,<SIZES>
        invoke HPROC, ADDR str&len&
        print fld$(ustr$(eax),COLWIDTH,1)
    ENDM
    print chr$(13,10)

    print fld$(chr$("=========="),HDRWIDTH)
    %FOR len,<SIZES>
        invoke StrLen,ADDR str&len&
        print fld$(" ====",COLWIDTH)
    ENDM
    print chr$(13,10)

    %FOR proc,<PROCS>
        print fld$(chr$("&proc&"),HDRWIDTH)
        %FOR len,<SIZES>
            counter_begin LOOPCOUNT, HIGH_PRIORITY_CLASS
                invoke proc,ADDR str&len&
            counter_end
            mov ebx,eax
            print fld$(ustr$(ebx),COLWIDTH,1)
        ENDM
        print chr$(13,10)
    ENDM
    mov   eax,input(13,10,"Press enter to exit...")
    exit

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

szLength proc src:DWORD
	mov  edx, [esp + 4]     ; point edx to start of string
	test  edx, 3
	jz   lenscan            ; branch ahead if already aligned
	mov  ecx, edx
        and  edx, 0FFFFFFFCh ; ~3; edx points to aligned addr
	and  ecx, 3             ; ecx = bytes to skip
	shl  ecx, 3             ; ecx = bits to skip
	mov  eax, 1
	shl  eax, cl            ; put cl 1's into eax from the bottom up
	sub  eax, 1
	or   eax, [edx]         ; combine with first four bytes
	jmp  resume             ; catch up with the aligned search...

	align	4
lenscan: mov  eax, [edx]        ; load next four bytes into eax
resume: add  edx, 4             ; advance ptr
	lea  ecx, [eax - 1010101h]
	not  eax                ; for each byte in ecx: (charval-1) & ~charval & 80h
	and  eax, ecx
	and  eax, 80808080h
	jz   lenscan            ; repeat while no zeros found

	sub  edx, [esp + 4]     ; subtract the base address
	test  eax, 8080h        ; test first two bytes
	jz   upper2             ; jmp if not found in the lower 2 bytes
	shr  eax, 8             ; set carry from bit7 of 1st byte
	sbb  edx, 3             ; edx = (edx-4) + (1-carry)
	mov  eax, edx           ; return as the result
	ret  1*4

upper2:  shl  eax, 9            ; set carry from bit7 of 3rd byte
	sbb  edx, 1	        ; edx = (edx-2) + (1-carry)
	mov  eax, edx           ; return as the result
	ret  1*4
szLength endp


OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

lszLenSSE proc pString:DWORD    ; Donkey's SSE strlen for long strings
.xmm
        mov eax,[esp+4]
	nop
        nop                     ; fill in stack frame+mov to 8 bytes

	pxor mm0,mm0
        nop                     ; fill pxor to 4 bytes
	pxor mm1,mm1
        nop                     ; fill pxor to 4 bytes

    @@:                         ; this is aligned to 16 bytes
        movq mm0,[eax]
        pcmpeqb mm0,mm1
	add eax,8
        pmovmskb ecx,mm0
        or ecx,ecx
        jz @B

        sub eax,[esp+4]

	bsf ecx,ecx
	sub eax,8
	add eax,ecx

	emms

        ret 1*4

lszLenSSE endp

align 16

Ratch proc junk:dword      ; from Ratch           ;it all begins here
 MOV EAX,[ESP+DWORD]       ;address of string

 .REPEAT                   ;searching string ....
   MOV EDX,[EAX]           ;next 4 byte gulp (DWORD)
   ADD EAX,DWORD           ;EAX=character pointer
   LEA ECX,[EDX-01010101H] ;propagate if byte is zero
   NOT EDX                 ;set up test pattern
   AND EDX,ECX             ;leftmost bit of zero byte should now be set
   AND EDX,080808080H      ;sieve out zero bytes
 .UNTIL !ZERO?             ;check the next DWORD

                           ;we now know the current DWORD contains a zero byte
 SUB EAX,DWORD+BYTE        ;compensate for entry additions into loops

 .REPEAT                   ;searching current DWORD ...
   INC EAX                 ;increase word count if no carry from shift
   ROR EDX,8               ;bring leftmost bit of each byte into carry flag
 .UNTIL CARRY?             ;if carry flag set, byte is zero

 SUB EAX,[ESP+DWORD]       ;subtract beginning of string to get length

 RET DWORD                 ;all done, and string length in EAX

Ratch endp

align 16

FStrLen proc string:dword
        mov     ecx, [esp+4]
        xor     eax, eax            ; clear initial size 
    @@:
        mov     edx, [ecx+4*eax]
        lea     edx, [edx-1010101h] ; sub 1 from each byte in eax
        add     eax,1               ; ready for next dword
        and     edx, 80808080h      ; check sign bit in all byte
        jz      @B                  ; more to do until we have a sign
        test    edx, 000000FFh      ; is byte-1 zero?
        jnz     C_minus4            ;
        test    edx, 0000FF00h      ; is byte-2 zero?
        jnz     C_minus3            ;
        test    edx, 00FF0000h      ; is byte-3 zero?
        jnz     C_minus2            ;
    C_minus1:
        lea     eax,[4*eax-1]
        ret     1*4
    C_minus2:
        lea     eax,[4*eax-2]
        ret     1*4
    C_minus3:
        lea     eax,[4*eax-3]
        ret     1*4
    C_minus4:
        lea     eax,[4*eax-4]
        ret     1*4

FStrLen endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

end start
